"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
/** The `ArrayFieldItemTemplate` component is the template used to render an items of an array.
 *
 * @param props - The `ArrayFieldTemplateItemType` props for the component
 */
function ArrayFieldItemTemplate(props) {
    var children = props.children, className = props.className, disabled = props.disabled, hasToolbar = props.hasToolbar, hasMoveDown = props.hasMoveDown, hasMoveUp = props.hasMoveUp, hasRemove = props.hasRemove, hasCopy = props.hasCopy, index = props.index, onCopyIndexClick = props.onCopyIndexClick, onDropIndexClick = props.onDropIndexClick, onReorderClick = props.onReorderClick, readonly = props.readonly, registry = props.registry, uiSchema = props.uiSchema;
    var _a = registry.templates.ButtonTemplates, CopyButton = _a.CopyButton, MoveDownButton = _a.MoveDownButton, MoveUpButton = _a.MoveUpButton, RemoveButton = _a.RemoveButton;
    var btnStyle = {
        flex: 1,
        paddingLeft: 6,
        paddingRight: 6,
        fontWeight: 'bold',
    };
    return (react_1.default.createElement("div", { className: className + ' row' },
        react_1.default.createElement("div", { className: hasToolbar ? 'col col--9' : 'col col--12' }, children),
        hasToolbar && (react_1.default.createElement("div", { className: 'col col--3 array-item-toolbox' },
            react_1.default.createElement("div", { className: 'btn-group', style: {
                    display: 'flex',
                    justifyContent: 'space-around',
                } },
                (hasMoveUp || hasMoveDown) && (react_1.default.createElement(MoveUpButton, { style: btnStyle, disabled: disabled || readonly || !hasMoveUp, onClick: onReorderClick(index, index - 1), uiSchema: uiSchema, registry: registry })),
                (hasMoveUp || hasMoveDown) && (react_1.default.createElement(MoveDownButton, { style: btnStyle, disabled: disabled || readonly || !hasMoveDown, onClick: onReorderClick(index, index + 1), uiSchema: uiSchema, registry: registry })),
                hasCopy && (react_1.default.createElement(CopyButton, { style: btnStyle, disabled: disabled || readonly, onClick: onCopyIndexClick(index), uiSchema: uiSchema, registry: registry })),
                hasRemove && (react_1.default.createElement(RemoveButton, { style: btnStyle, disabled: disabled || readonly, onClick: onDropIndexClick(index), uiSchema: uiSchema, registry: registry })))))));
}
exports.default = ArrayFieldItemTemplate;
