"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var utils_1 = require("@rjsf/utils");
/** The `ArrayFieldTemplate` component is the template used to render all items in an array.
 *
 * @param props - The `ArrayFieldTemplateItemType` props for the component
 */
function ArrayFieldTemplate(props) {
    var canAdd = props.canAdd, className = props.className, disabled = props.disabled, idSchema = props.idSchema, uiSchema = props.uiSchema, items = props.items, onAddClick = props.onAddClick, readonly = props.readonly, registry = props.registry, required = props.required, schema = props.schema, title = props.title;
    var uiOptions = (0, utils_1.getUiOptions)(uiSchema);
    var ArrayFieldDescriptionTemplate = (0, utils_1.getTemplate)('ArrayFieldDescriptionTemplate', registry, uiOptions);
    var ArrayFieldItemTemplate = (0, utils_1.getTemplate)('ArrayFieldItemTemplate', registry, uiOptions);
    var ArrayFieldTitleTemplate = (0, utils_1.getTemplate)('ArrayFieldTitleTemplate', registry, uiOptions);
    // Button templates are not overridden in the uiSchema
    var AddButton = registry.templates.ButtonTemplates.AddButton;
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("fieldset", { className: className + ' row', id: idSchema.$id },
            react_1.default.createElement(ArrayFieldTitleTemplate, { idSchema: idSchema, title: uiOptions.title || title, required: required, schema: schema, uiSchema: uiSchema, registry: registry }),
            react_1.default.createElement("div", { className: 'col col--12 array-item-list' },
                react_1.default.createElement("div", { className: 'container' }, items &&
                    items.map(function (_a) {
                        var key = _a.key, itemProps = __rest(_a, ["key"]);
                        return (react_1.default.createElement(ArrayFieldItemTemplate, __assign({ key: key }, itemProps)));
                    }))),
            canAdd && (react_1.default.createElement("div", { className: "col col--12" },
                react_1.default.createElement(AddButton, { className: 'array-item-add', onClick: onAddClick, disabled: disabled || readonly, uiSchema: uiSchema, registry: registry }))))));
}
exports.default = ArrayFieldTemplate;
