"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("@rjsf/utils");
/** The `FieldErrorTemplate` component renders the errors local to the particular field
 *
 * @param props - The `FieldErrorProps` for the errors being rendered
 */
function FieldErrorTemplate(props) {
    var _a = props.errors, errors = _a === void 0 ? [] : _a, idSchema = props.idSchema;
    if (errors.length === 0) {
        return null;
    }
    var id = (0, utils_1.errorId)(idSchema);
    return (react_1.default.createElement("div", null, errors
        .filter(function (elem) { return !!elem; })
        .map(function (error, index) {
        return (react_1.default.createElement("div", { className: 'alert alert--danger' }, error));
    })));
}
exports.default = FieldErrorTemplate;
var react_1 = __importDefault(require("react"));
