"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var utils_1 = require("@rjsf/utils");
var Label_1 = __importDefault(require("./Label"));
/** The `FieldTemplate` component is the template used by `SchemaField` to render any field. It renders the field
 * content, (label, description, children, errors and help) inside of a `WrapIfAdditional` component.
 *
 * @param props - The `FieldTemplateProps` for this component
 */
function FieldTemplate(props) {
    var id = props.id, label = props.label, children = props.children, errors = props.errors, help = props.help, description = props.description, hidden = props.hidden, required = props.required, displayLabel = props.displayLabel, registry = props.registry, uiSchema = props.uiSchema;
    var uiOptions = (0, utils_1.getUiOptions)(uiSchema);
    var WrapIfAdditionalTemplate = (0, utils_1.getTemplate)('WrapIfAdditionalTemplate', registry, uiOptions);
    if (hidden) {
        return react_1.default.createElement("div", { className: 'hidden' }, children);
    }
    return (react_1.default.createElement(WrapIfAdditionalTemplate, __assign({}, props),
        displayLabel && react_1.default.createElement(Label_1.default, { label: label, required: required, id: id }),
        displayLabel && description ? description : null,
        react_1.default.createElement("div", { className: 'col col--12' }, children),
        errors,
        help));
}
exports.default = FieldTemplate;
