"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var MarkdownDescription_1 = __importDefault(require("../MarkdownDescription/MarkdownDescription"));
var ExpansionTable_1 = __importDefault(require("../ExpansionTable/ExpansionTable"));
var Servers_1 = __importDefault(require("../Servers/Servers"));
var Links = /** @class */ (function (_super) {
    __extends(Links, _super);
    function Links() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Links.prototype.render = function () {
        var _a = this.props, links = _a.links, uiSchema = _a.uiSchema, components = _a.components;
        if (!links || links.length === 0) {
            return null;
        }
        return (react_1.default.createElement(ExpansionTable_1.default, { headers: ["Method", "Summary"] },
            react_1.default.createElement("tr", null,
                react_1.default.createElement("td", { colSpan: 6 }, links.map(function (link, i) { return (react_1.default.createElement("div", { style: { width: "100%" }, key: i },
                    react_1.default.createElement("details", { style: { width: "100%" }, open: uiSchema && uiSchema.links["ui:defaultExpanded"], key: i },
                        react_1.default.createElement("summary", { style: { justifyContent: "space-between" }, key: "links-header" },
                            react_1.default.createElement("div", { style: { display: "flex", justifyContent: "space-between", width: "100%", height: "100%" } },
                                react_1.default.createElement("h6", { className: "link-method" }, link.method),
                                react_1.default.createElement("span", { className: "link-summary" }, link.summary))),
                        react_1.default.createElement("section", { style: { display: "block" }, key: "links-body" },
                            link.description && react_1.default.createElement(MarkdownDescription_1.default, { uiSchema: uiSchema, source: link.description }),
                            link.params && react_1.default.createElement("h6", null, "Params"),
                            link.params && components && components.CodeBlock && react_1.default.createElement(components.CodeBlock, { className: "language-json" }, JSON.stringify(link.params, null, " ")),
                            link.params && !(components === null || components === void 0 ? void 0 : components.CodeBlock) &&
                                react_1.default.createElement("pre", null,
                                    react_1.default.createElement("code", null, JSON.stringify(link.params, null, " "))),
                            link.server && react_1.default.createElement("h6", { className: "link-server" }, "Server"),
                            link.server && react_1.default.createElement(Servers_1.default, { servers: [link.server], noTitle: true, components: components }))))); })))));
    };
    return Links;
}(react_1.Component));
exports.default = Links;
