"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var MarkdownDescription_1 = __importDefault(require("../MarkdownDescription/MarkdownDescription"));
var react_1 = __importDefault(require("react"));
var Links_1 = __importDefault(require("../Links/Links"));
var Tags_1 = __importDefault(require("../Tags/Tags"));
var Params_1 = __importDefault(require("../Params/Params"));
var ContentDescriptor_1 = __importDefault(require("../ContentDescriptor/ContentDescriptor"));
var ExamplePairings_1 = __importDefault(require("../ExamplePairings/ExamplePairings"));
var Errors_1 = __importDefault(require("../Errors/Errors"));
var lodash_1 = __importDefault(require("lodash"));
var defaultJsonViewOptions = {
    theme: "summerfruit:inverted",
    collapseStringsAfterLength: 25,
    displayDataTypes: false,
    displayObjectSize: false,
    indentWidth: 2,
    name: false,
};
var Method = function (_a) {
    var method = _a.method, uiSchema = _a.uiSchema, key = _a.key, methodPlugins = _a.methodPlugins, reactJsonOptions = _a.reactJsonOptions, onExamplePairingChange = _a.onExamplePairingChange, components = _a.components;
    reactJsonOptions = __assign(__assign({}, defaultJsonViewOptions), reactJsonOptions);
    if (!method) {
        return null;
    }
    if (lodash_1.default.isEmpty(method)) {
        return null;
    }
    var links = method.links;
    return (react_1.default.createElement("div", { id: method.name, key: key, className: "margin-bottom--sm" },
        react_1.default.createElement("div", { style: { marginBottom: "var(--ifm-heading-margin-bottom)" } },
            react_1.default.createElement("h1", { key: method.name, className: "method-name", style: { display: "inline", marginRight: "3px" } }, method.name),
            react_1.default.createElement("span", { key: method.summary, className: "method-summary" }, method.summary)),
        method.tags && method.tags.length > 0 &&
            react_1.default.createElement("section", { key: "tags" },
                react_1.default.createElement(Tags_1.default, { tags: method.tags })),
        method.description &&
            react_1.default.createElement("section", { key: "description" },
                react_1.default.createElement(MarkdownDescription_1.default, { uiSchema: uiSchema, source: method.description, className: "method-description" })),
        method.params && method.params.length > 0 &&
            react_1.default.createElement("section", { key: "params" },
                react_1.default.createElement("div", { style: { marginBottom: "var(--ifm-heading-margin-bottom)" } },
                    react_1.default.createElement("h2", { style: { display: 'inline', marginRight: '3px' } }, "Params"),
                    react_1.default.createElement("span", null,
                        "(",
                        method.params.length,
                        ")")),
                react_1.default.createElement(Params_1.default, { params: method.params, uiSchema: uiSchema })),
        method.result &&
            react_1.default.createElement("section", { key: "result-title" },
                react_1.default.createElement("h2", null, "Result"),
                react_1.default.createElement(ContentDescriptor_1.default, { contentDescriptor: method.result, hideRequired: true, uiSchema: uiSchema })),
        method.errors && method.errors.length > 0 &&
            react_1.default.createElement("section", { key: "errors" },
                react_1.default.createElement("h2", null, "Errors"),
                react_1.default.createElement(Errors_1.default, { errors: method.errors, reactJsonOptions: reactJsonOptions })),
        react_1.default.createElement("br", null),
        method.examples && method.examples.length > 0 &&
            react_1.default.createElement("section", { key: "examples" },
                react_1.default.createElement("h2", null, "Examples"),
                react_1.default.createElement(ExamplePairings_1.default, { uiSchema: uiSchema, components: components, examples: method.examples, onExamplePairingChange: onExamplePairingChange, method: method, reactJsonOptions: reactJsonOptions })),
        links && links.length > 0 &&
            react_1.default.createElement("section", { key: "links-title" },
                react_1.default.createElement("h2", null, "Links"),
                react_1.default.createElement("section", { key: "links" },
                    react_1.default.createElement(Links_1.default, { links: links, components: components }))),
        methodPlugins && methodPlugins.length > 0 &&
            react_1.default.createElement("section", { key: "method-plugins" }, methodPlugins.map(function (CompDef) {
                return (react_1.default.createElement(CompDef, { openrpcMethodObject: method }));
            }))));
};
exports.default = Method;
