"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var react_dom_1 = __importDefault(require("react-dom"));
var Method_1 = __importDefault(require("./Method"));
it("renders without crashing", function () {
    var div = document.createElement("div");
    react_dom_1.default.render(react_1.default.createElement(Method_1.default, { method: { name: "foo", params: [] }, uiSchema: {} }), div);
    react_dom_1.default.unmountComponentAtNode(div);
});
it("renders empty with no schema", function () {
    var div = document.createElement("div");
    react_dom_1.default.render(react_1.default.createElement(Method_1.default, null), div);
    expect(div.innerHTML).toBe("");
    react_dom_1.default.unmountComponentAtNode(div);
});
it("renders empty with empty method", function () {
    var div = document.createElement("div");
    react_dom_1.default.render(react_1.default.createElement(Method_1.default, { method: {} }), div);
    expect(div.innerHTML).toBe("");
    react_dom_1.default.unmountComponentAtNode(div);
});
it("renders schema methods name", function () {
    var div = document.createElement("div");
    var schema = {
        methods: [
            {
                name: "get_pet",
            },
        ],
    };
    react_dom_1.default.render(react_1.default.createElement(Method_1.default, { method: schema.methods[0], uiSchema: {} }), div);
    expect(div.innerHTML.includes("get_pet")).toBe(true);
    react_dom_1.default.unmountComponentAtNode(div);
});
