"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var Params_1 = __importDefault(require("../Params/Params"));
var ContentDescriptor_1 = __importDefault(require("../ContentDescriptor/ContentDescriptor"));
var ExamplePairings_1 = __importDefault(require("../ExamplePairings/ExamplePairings"));
var Errors_1 = __importDefault(require("../Errors/Errors"));
var Links_1 = __importDefault(require("../Links/Links"));
var Tags_1 = __importDefault(require("../Tags/Tags"));
var MarkdownDescription_1 = __importDefault(require("../MarkdownDescription/MarkdownDescription"));
var Methods = /** @class */ (function (_super) {
    __extends(Methods, _super);
    function Methods() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Methods.prototype.render = function () {
        var _this = this;
        var _a = this.props, schema = _a.schema, uiSchema = _a.uiSchema, onMethodToggle = _a.onMethodToggle;
        if (!schema) {
            return null;
        }
        var methods = schema.methods;
        var methodsExist = methods && methods.length > 0;
        if (!schema || !schema.methods || !methodsExist) {
            return null;
        }
        return (react_1.default.createElement("div", { className: "methods-root" },
            react_1.default.createElement("h3", null, "Methods"),
            methods.map(function (method, i) {
                var links = method.links;
                return (react_1.default.createElement("details", { id: method.name, key: i + method.name, onToggle: function (event) {
                        if (onMethodToggle) {
                            onMethodToggle(method.name, event.currentTarget.open);
                        }
                    }, className: "alert alert--info margin-bottom--sm", open: uiSchema &&
                        uiSchema.methods &&
                        (uiSchema.methods["ui:defaultExpanded"] === true ||
                            (uiSchema.methods["ui:defaultExpanded"] && uiSchema.methods["ui:defaultExpanded"][method.name] === true)) },
                    react_1.default.createElement("summary", { style: { cursor: "pointer" } },
                        react_1.default.createElement("h4", { key: method.name, className: "method-name", style: { display: "inline", marginRight: "3px" } }, method.name),
                        react_1.default.createElement("span", { key: method.summary, className: "method-summary" }, method.summary)),
                    method.tags && method.tags.length > 0 &&
                        react_1.default.createElement("section", { key: "tags" },
                            react_1.default.createElement(Tags_1.default, { tags: method.tags })),
                    method.description &&
                        react_1.default.createElement("section", { key: "description" },
                            react_1.default.createElement(MarkdownDescription_1.default, { uiSchema: uiSchema, source: method.description, className: "method-description" })),
                    method.params && method.params.length > 0 &&
                        react_1.default.createElement("section", { key: "params-title" },
                            react_1.default.createElement("h5", null, "Params")),
                    method.params &&
                        react_1.default.createElement("section", { key: "params" },
                            react_1.default.createElement(Params_1.default, { params: method.params, uiSchema: uiSchema })),
                    method.result &&
                        react_1.default.createElement("section", { key: "result-title" },
                            react_1.default.createElement("h5", null, "Result")),
                    method.result && method.result.schema &&
                        react_1.default.createElement("section", { key: "result" },
                            react_1.default.createElement(ContentDescriptor_1.default, { contentDescriptor: method.result, defaultExpanded: true, hideIcon: true, hideRequired: true, uiSchema: uiSchema })),
                    method.errors && method.errors.length > 0 &&
                        react_1.default.createElement("section", { key: "errors" },
                            react_1.default.createElement(Errors_1.default, { errors: method.errors, reactJsonOptions: _this.props.reactJsonOptions })),
                    react_1.default.createElement(ExamplePairings_1.default, { uiSchema: uiSchema, examples: method.examples, method: method, reactJsonOptions: _this.props.reactJsonOptions }),
                    links && links.length > 0 &&
                        react_1.default.createElement("section", { key: "links-title" },
                            react_1.default.createElement("h5", null, "Links")),
                    links && links.length > 0 &&
                        react_1.default.createElement("section", { key: "links" },
                            react_1.default.createElement(Links_1.default, { links: links, reactJsonOptions: _this.props.reactJsonOptions })),
                    _this.props.methodPlugins && _this.props.methodPlugins.length > 0 &&
                        react_1.default.createElement("section", { key: "method-plugins" }, _this.props.methodPlugins.map(function (CompDef) {
                            return (react_1.default.createElement(CompDef, { openrpcMethodObject: method }));
                        }))));
            })));
    };
    return Methods;
}(react_1.Component));
exports.default = Methods;
